using System;
namespace BTL
{
    public class MyPou606319703
    {
        // input
        public bool Button; // кнопка пешехода
        
        // output
        public bool R, Y, G; //светофор для машин
        public bool R2, G2; // светофор для пешеходов
        
        //local
        public bool BB; 
        public int Branch1 = 1;
        public int Branch1_Prev;
        public int Branch1_T;
        public bool Branch1_Pulse = true;
        public int Branch2 = 1;
        
        public void Process()
        {
            /*Code*/
            if (Branch1_Pulse)
            {
                Branch1_Prev = Branch1;
                Branch1_T = Environment.TickCount;
            }
            switch (Branch1)
            {
                case 1: /*S1*/
                {
                    /*машины едут, пешеходы стоят*/
                    R = Y =  G2 = false;
                    G = R2 = true;
                    /*пешеход нажал кнопку*/
                    if (BB)
                    {
                        /*прошло ли достатоно времени для потока машин*/
                        if ((Environment.TickCount - Branch1_T) > 5000)
                        {
                            Branch1 = 2;
                        }
                    }
                }
                break;
                case 2:
                {
                    /*машинам желтый*/
                    Y = true; G = false;
                    /*выдержать желтый*/
                    if ((Environment.TickCount - Branch1_T) > 2000)
                    {
                        Branch1 = 3;
                    }
                }
                break;
                case 3:
                {
                    /*машины стоят*/
                    Y = false; R = true;
                    /*люди идут*/
                    R2 = false; G2 = true;
                    /*пусть люди походят*/
                    if ((Environment.TickCount - Branch1_T) > 5000)
                    {
                        Branch1 = 4;
                    }
                }
                break;
                case 4:
                {
                    /*люди стоят*/
                    R2 = true; G2 = false;
                    /*игнорировать нажатия кнопки пока люди ходили*/
                    BB = false;
                    /*машинам желтый*/
                    Y = true; R = false;
                    /*коротенькая пауза*/
                    if ((Environment.TickCount - Branch1_T) > 1000)
                    {
                        Branch1 = 1; /*S1*/
                    }
                }
                break;
            }
            Branch1_Pulse = Branch1 != Branch1_Prev;
            switch (Branch2)
            {
                case 1: /*S1*/
                {
                    /*пешеход нажал кнопку*/
                    if (Button )
                    {
                        Branch2 = 2;
                    }
                }
                break;
                case 2:
                {
                    /*пешеход отжал кнопку*/
                    if (!(Button ))
                    {
                        /*запомнить это нажатие*/
                        BB = true;
                        Branch2 = 1; /*S1*/
                    }
                }
                break;
            }
            
            
        }
    }
}